#!/bin/sh
# automount manager by thowi
VERSION=15
LINE="---------------------------------------------------------"
AMHOME=/usr/lib/enigma2/python/Plugins/Extensions/Automount 
INSTALLDIR=/var/tmp
LIBDIR=/lib/modules/2.6.12.6/kernel/autofs 
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions/Automount 
MASTER=/etc/auto.master
MASTERTMP=$INSTALLDIR/auto.master
AMTMP=$INSTALLDIR/auto.tmp
AUTOFS=/etc/init.d/autofs
USB=/etc/auto.usb
MISC=/etc/auto.misc
USBPATH="/dev/scsi/host0/bus0/target0/lun0/part1"
echo $LINE
echo "automount plugin py thowi Version $VERSION"

case $1 in
"enable" )
echo $LINE
mkdir $LIBDIR > /dev/null 2>&1
mkdir $PLUGINDIR > /dev/null 2>&1
echo "Installing autofs kernel module and ipk package ..."
cp $AMHOME/autofs4.ko $LIBDIR/autofs4.ko
ipkg install $AMHOME/autofs_4.1.4-r1_mipsel.ipk
modprobe autofs4 > /dev/null 2>&1
if [ ! -f /bin/bash ]; then
   echo "Image has no Bash Shell - copying from automount kit ..."
   cp $AMHOME/bash /bin/bash
fi
echo "Patching startup script for Dreambox"
sed -ie s!/etc/debian_version!/etc/image-version!g /etc/init.d/autofs
sed -ie s!"mktemp -t"!"mktemp"!g /etc/init.d/autofs
sed -ie s!"ps axwww"!"ps ax "!g /etc/init.d/autofs
sed -ie s!"ps axww"!"ps ax "!g /etc/init.d/autofs

echo "Linking to /etc/rc3.d for automatic startup ..."
ln -sf $AUTOFS /etc/rc3.d/S98autofs
echo "Starting autofs dameon ..."
$AUTOFS start

echo "Installation of automount finished"
;;
"disable")
echo $LINE
echo "Stopping autofs dameon ..."
$AUTOFS stop
echo "Remove Link to /etc/rc3.d for automatic startup ..."
rm  /etc/rc3.d/S98autofs > /dev/null 2>&1
;;
"disableusb")
echo $LINE
echo "Removing USB stick from /etc/auto.master"
grep -v /media $MASTER > $MASTERTMP
cp  $MASTERTMP $MASTER
rm $USB > /dev/null 2>&1
echo $LINE
cat $MASTER
echo $LINE
$AUTOFS reload
echo $LINE
;;
"enableusb")
echo $LINE
echo "Loading USB Kernel Modules ..."
             modprobe ohci-hcd > /dev/null 2>&1
             modprobe sd_mod > /dev/null 2>&1
             modprobe usb-storage > /dev/null 2>&1
# first remove USB if called multiply
grep -v /media $MASTER > $MASTERTMP
cp  $MASTERTMP $MASTER
rm $USB > /dev/null 2>&1
# now add USB
mkdir /media/misc > /dev/null 2>&1
echo "/media/misc $USB" >> $MASTER
echo "usb      -fstype=ext3   :$USBPATH" > $USB
echo $LINE
cat $MASTER
echo $LINE
$AUTOFS reload
echo $LINE
;;
"removesamba")
echo $LINE
echo "Removing Samba from $MISC"
grep -v samba $MISC > $AMTMP
cp $AMTMP $MISC 
echo $LINE
cat $MISC
echo $LINE
$AUTOFS reload
echo $LINE
;;
"addsamba")
echo $LINE
echo "Samba Client should be started/installed already !"
if [ $# -lt 2 ]; then
echo "No Server name or IP Address passed, cann't add samba Mountpoint, sorry !"
exit 1
fi
if [ $# -lt 3 ]; then
echo "No Share name passed, cann't add samba Mountpoint, sorry !"
exit 1
fi
echo "//$2/$3 username=$4 password=$5"
echo "Removing old Samba mountpoint"
grep -v samba $MISC > $AMTMP
cp $AMTMP $MISC 
# now add Samba
#mkdir /misc/samba > /dev/null 2>&1
if [ -z $4 ]; then
if [ -z $5 ]; then
   echo "No Username and Password Passed"
   echo "samba        -fstype=smbfs ://$2/$3" >> $MISC
fi
else 
if [ -z $5 ]; then
   echo "No Password Passed"
   echo "samba        -fstype=smbfs,username=$4 ://$2/$3" >> $MISC
else
   echo "samba        -fstype=smbfs,username=$4,password=$5 ://$2/$3" >> $MISC
fi
fi
echo $LINE
cat $MISC
echo $LINE
$AUTOFS reload
echo $LINE
;;
"removecifs")
echo $LINE
echo "Removing CIFS from $MISC"
grep -v cifs $MISC > $AMTMP
cp $AMTMP $MISC 
echo $LINE
cat $MISC
echo $LINE
$AUTOFS reload
echo $LINE
;;
"addcifs")
echo $LINE
echo "CIFS should be started/installed already !"
if [ $# -lt 2 ]; then
echo "No Server name or IP Address passed, cann't add CIFS Mountpoint, sorry !"
exit 1
fi
if [ $# -lt 3 ]; then
echo "No Share name passed, cann't add CIFS Mountpoint, sorry !"
exit 1
fi
echo "//$2/$3 username=$4 password=$5"
echo "Removing old CIFS mountpoint"
grep -v cifs $MISC > $AMTMP
cp $AMTMP $MISC 
# now add CIFS
#mkdir /misc/cifs > /dev/null 2>&1
if [ -z $4 ]; then
if [ -z $5 ]; then
   echo "No Username and Password Passed"
   echo "cifs         -fstype=cifs ://$2/$3" >> $MISC
fi
else 
if [ -z $5 ]; then
   echo "No Password Passed"
   echo "cifs         -fstype=cifs,username=$4 ://$2/$3" >> $MISC
else
   echo "cifs         -fstype=cifs,username=$4,password=$5 ://$2/$3" >> $MISC
fi
fi
echo $LINE
cat $MISC
echo $LINE
$AUTOFS reload
echo $LINE
;;
"reload")
echo $LINE
$AUTOFS reload
echo $LINE
;;
"start")
echo $LINE
$AUTOFS start
echo $LINE
;;
"stop")
echo $LINE
$AUTOFS stop
echo $LINE
;;
"restart")
echo $LINE
$AUTOFS restart
echo $LINE
;;
"status")
echo $LINE
$AUTOFS status
echo $LINE
;;
"getmounts")
echo $LINE
$AUTOFS getmounts
echo $LINE
;;
"active")
echo $LINE
echo "not implemented on Dreambox ..."
echo $LINE
;;
*)
echo "Nothing to be done ..."
;;
esac
exit 0
