#!/bin/sh
#
VERSION=$1
#
INSTALLDIR=/var/tmp
AMHOME=/usr/lib/enigma2/python/Plugins/Extensions/Automount
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions

cd $AMHOME
if [ -z $VERSION ]; then
echo "Version needs to be passed as argument, cann't do anything"
echo "---------------------------------------------"
exit 1
fi
 
rm $INSTALLDIR/* > /dev/null 2>&1
rm $AMHOME/automount*.tar > /dev/null 2>&1
rm $MBHOME/*.tmp > /dev/null 2>&1

echo "---------------------------------------------"
echo "Creating Automount Installation Kit Version: $VERSION"
echo "---------------------------------------------"

if [ ! -d $INSTALLDIR ]; then
mkdir $INSTALLDIR
fi
# remove when linked (when filled will fail)
dos2unix $AMHOME/readme*.txt
rm $PLUGINDIR/Automount > /dev/null 2>&1
#
cd /
tar -cf $INSTALLDIR/automount$VERSION.tar $AMHOME/auto*.ipk $AMHOME/auto*.ko $AMHOME/bash /usr/lib/enigma2/python/Plugins/Extensions/Automount/*.py   $AMHOME/automount.sh $AMHOME/readme*.txt $AMHOME/makekit.sh  
echo " Kit contains "
echo "---------------------------------------------"
tar -tvf $INSTALLDIR/automount$VERSION.tar
echo "---------------------------------------------"
if [ ! -f /usr/bin/bzip2 ]; then
cd /
ipkg install $INSTALLDIR/bzip2*
cd $AMHOME
echo "---------------------------------------------"
fi
echo "Copying kit to $INSTALLDIR"
echo "---------------------------------------------"
bzip2 -f $INSTALLDIR/automount$VERSION.tar
ls -1alh $INSTALLDIR/automount$VERSION.tar.*
echo "---------------------------------------------"
cd $AMHOME
exit 0

