#
from enigma import *
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from Plugins.Plugin import PluginDescriptor

import os

###############################################################################
# path to automount  - could be also a Link
###############################################################################
automount_path = "/usr/lib/enigma2/python/Plugins/Extensions/Automount"
automount_script = "automount.sh"
automount_readme = "readme.txt"
automount_pluginpath = "/usr/lib/enigma2/python/Plugins/Extensions/Automount"

###############################################################################
# versionstring
###############################################################################
automount_pluginversion = "1.5"

###############################################################################
def main(session,**kwargs):
    try:    
     	session.open(Automount)
    except:
        print "[AUTOMOUNT] Pluginexecution failed"
###############################################################################
def autostart(reason,**kwargs):
    if reason == 0:
        print "[AUTOMOUNT] no autostart"
###############################################################################
def Plugins(**kwargs):
    return PluginDescriptor(
        name="Automount", 
        description="manage automount dameon & mountpoints", 
        where = PluginDescriptor.WHERE_PLUGINMENU,
        fnc = main
        )
###############################################################################
###############################################################################
class Automount(Screen):
    skin = """
        <screen position="100,100" size="500,400" title="Automount Menu" >
            <widget name="menu" position="10,10" size="490,390" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = Automount.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append((_("enable automount"), "enable"))
        list.append((_("disable automount"), "disable"))
        list.append((_("start automount daemon"), "start"))
        list.append((_("stop automount daemon"), "stop"))
        list.append((_("restart automount daemon"), "restart"))
        list.append((_("reload automount daemon"), "reload"))
        list.append((_("status of automount daemon"), "status"))
        list.append((_("mountpoints of automount daemon"), "getmounts"))
        list.append((_("add samba mount"), "addsamba"))
        list.append((_("remove samba mount"), "removesamba"))
        list.append((_("add cifs mount"), "addcifs"))
        list.append((_("remove cifs mount"), "removecifs"))
#        list.append((_("enable usb automount"), "enableusb"))
#        list.append((_("disable usb automount"), "disableusb"))
        list.append((_("help"), "help"))        
        list.append((_("about"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "addsamba":
               SambaWizzard(self.session)
           if returnValue is "addcifs":
               CifsWizzard(self.session)
           if returnValue is "enable":
               title = "enabling automount plugin"
               cmd = "%s/%s enable" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "disable":
               title = "disabling automount plugin"
               cmd = "%s/%s disable" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "start":
               title = "starting automount dameon"
               cmd = "%s/%s start" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "stop":
               title = "stopping automount dameon"
               cmd = "%s/%s stop" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "restart":
               title = "restarting automount dameon"
               cmd = "%s/%s restart" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "reload":
               title = "restarting automount dameon"
               cmd = "%s/%s reload" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "status":
               title = "status of automount dameon"
               cmd = "%s/%s status" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "getmounts":
               title = "mount points of automount dameon"
               cmd = "%s/%s getmounts" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "enableusb":
               title = "enable automount of USB stick"
               cmd = "%s/%s enableusb" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "disableusb":
               title = "disable automount of USB stick"
               cmd = "%s/%s disableusb" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "removesamba":
               title = "removing samba mountpoint"
               cmd = "%s/%s removesamba" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "removecifs":
               title = "removing CIFS mountpoint"
               cmd = "%s/%s removecifs" % (automount_pluginpath,automount_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "help":
               title = "automount plugin readme.txt"
               cmd = "cat %s/%s" % (automount_pluginpath,automount_readme)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "about":
             self.session.open(MessageBox,_("Automount Enigma2 Plugin %s\n\nAutomount by thowi\n\nEnjoy managing Automount with your remote control !" % automount_pluginversion), MessageBox.TYPE_INFO)

###############################################################################

class SambaWizzard(Screen):
    def __init__(self, session):

        self.session = session
        self.askForTargetServer()
        
    def askForTargetServer(self):
	    self.session.openWithCallback(self.askForTargetShare,InputBox, title=_("Please enter remote Server Name or IP Adress"), text="192.168.0.2", maxSize=False, type=Input.TEXT)

    def askForTargetShare(self,server):
        if server is None:
            self.skipSamba("Server is NONE, skipping samba")
        else:
            self.server = server
	    self.session.openWithCallback(self.askForUser,InputBox, title=_("Please enter remote Share Name"), text="sharename", maxSize=False, type=Input.TEXT)

    def askForUser(self,share):
        if share is None:
            self.skipSamba("Share is NONE, skipping samba")
        else:
            self.share = share
	    self.session.openWithCallback(self.askForPassword,InputBox, title=_("Please enter remote Username"), text="username", maxSize=False, type=Input.TEXT)

    def askForPassword(self,user):
        if user is None:
            self.skipSamba("Username is NONE, skipping samba")
        else:
            self.user = user
	    self.session.openWithCallback(self.askForConfirm,InputBox, title=_("Please enter remote Password"), text="password", maxSize=False, type=Input.TEXT)

    def askForConfirm(self,password):
        if password is None:
            self.skipSamba("Password is NONE, skipping samba")
        else:
            self.password = password
            self.session.openWithCallback(self.AddSamba,MessageBox,_("are you sure to add samba mount\nServer: %s\nShare: %s " % (self.server, self.share)), MessageBox.TYPE_YESNO)

    def AddSamba(self,answer):
        if answer is None:
            self.skipSamba("answer is None")
        if answer is False:
            self.skipSamba("you were not confirming")
        else:
            title = "add samba mountpoint //%s/%s Username:%s Password:%s" %(self.server,self.share,self.user,self.password)
            cmd = "%s/%s addsamba %s %s %s %s" % (automount_pluginpath,automount_script,self.server,self.share,self.user,self.password)
            self.session.open(Console,_(title),[cmd])
            
    def skipSamba(self,reason):
        self.session.open(MessageBox,_("adding Samba mount was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        

###############################################################################

class CifsWizzard(Screen):
    def __init__(self, session):

        self.session = session
        self.askForCifsTargetServer()
        
    def askForCifsTargetServer(self):
	    self.session.openWithCallback(self.askForCifsTargetShare,InputBox, title=_("Please enter remote Server Name or IP Adress"), text="192.168.0.2", maxSize=False, type=Input.TEXT)

    def askForCifsTargetShare(self,server):
        if server is None:
            self.skipCifs("Server is NONE, skipping CIFS")
        else:
            self.server = server
	    self.session.openWithCallback(self.askForCifsUser,InputBox, title=_("Please enter remote Share Name"), text="sharename", maxSize=False, type=Input.TEXT)

    def askForCifsUser(self,share):
        if share is None:
            self.skipCifs("Share is NONE, skipping CIFS")
        else:
            self.share = share
	    self.session.openWithCallback(self.askForCifsPassword,InputBox, title=_("Please enter remote Username"), text="username", maxSize=False, type=Input.TEXT)

    def askForCifsPassword(self,user):
        if user is None:
            self.skipCifs("Username is NONE, skipping CIFS")
        else:
            self.user = user
	    self.session.openWithCallback(self.askForCifsConfirm,InputBox, title=_("Please enter remote Password"), text="password", maxSize=False, type=Input.TEXT)

    def askForCifsConfirm(self,password):
        if password is None:
            self.skipCifs("Password is NONE, skipping CIFS")
        else:
            self.password = password
            self.session.openWithCallback(self.AddCifs,MessageBox,_("are you sure to add CIFS mount\nServer: %s\nShare: %s " % (self.server, self.share)), MessageBox.TYPE_YESNO)

    def AddCifs(self,answer):
        if answer is None:
            self.skipCifs("answer is None")
        if answer is False:
            self.skipCifs("you were not confirming")
        else:
            title = "add CIFS mountpoint //%s/%s Username:%s Password:%s" %(self.server,self.share,self.user,self.password)
            cmd = "%s/%s addcifs %s %s %s %s" % (automount_pluginpath,automount_script,self.server,self.share,self.user,self.password)
            self.session.open(Console,_(title),[cmd])
            
    def skipCifs(self,reason):
        self.session.open(MessageBox,_("adding CIFS mount was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        



        
        
